#ifndef MYMODEL_H
#define MYMODEL_H

#include <vector>
using namespace std;

#include "point.h"
#include "color.h"
#include "curves/curve.h"

class MyModel
{
 public:
  MyModel();
  ~MyModel();
  bool isEmpty() { return (m_curves.size() < 1); };
  vector<Curve*> getCurves() { return m_curves; };
  void getBoundBox(double* _xmin, double* _xmax,
                   double* _ymin, double* _ymax);
  void selectPick( double _x, double _y, double _tol, bool _shiftkey );
  void selectFence( double _xmin, double _xmax,
                    double _ymin, double _ymax, bool _shiftkey );
  void insertCurve( Curve* _curve );
  void delCurve( int _curveId );
  void delAllCurves();
  void delSelectedCurves();
  bool snapToCurve( double* _x, double* _y, double _tol );

 protected:
  vector<Curve*> m_curves;
};

#endif // MYMODEL_H
